<template>

	<div class="flex">
		<AppBreadcrumb />
		<div class="flex-1">&nbsp;</div>
		<ItemsSorter :options="sortOptions" v-model="sort" @update:modelValue="sort = $event" />
	</div>
	
	<ProductList :products="pageItems" :loading="loading" class="my-4 md:my-8" />

	<AppPagination :currentPage="currentPage" :totalPages="totalPages" @pageChanged="changePage($event)" v-if="!loading" />

</template>

<script>
import productsService from '../services/products-service';

import ProductList from '../components/ProductList.vue';
import AppPagination from '../components/AppPagination.vue';
import AppBreadcrumb from '../components/AppBreadcrumb.vue';
import ItemsSorter from '../components/ItemsSorter.vue';

import itemsPageMixin from '../mixins/itemsPageMixin';
import productsSortOptions from '../data/productsSortOptions';

/**
 * This page represents the landing page for users coming to the site.
 * For now it has been implemented as a simple list of all products currently available on the website.
 * In the future, it could use some heuristics to display mosre relevant products, like new items or offers.
 * It could also show some products particularly relevant to the current user, if a login system is implemented.
 */
export default {
	mixins: [
		itemsPageMixin
	],
	data() {
		return {
			sortOptions: productsSortOptions
		}
	},
	async created() {
		this.loading = true;

		// Load all products.
		this.items = await productsService.getAllProducts().catch( err => {
			console.error( `An error occured while retrieving all products`, err );
			return [];
		});
		
		// If we were browsing a given page, restore that page.
		if ( this.$route.query.page )
			this.currentPage = Number( this.$route.query.page ) - 1;

		this.loading = false;
	},
	methods: {
		changePage(newPageIndex) {

			// Update data according to the new page.
			this.currentPage = newPageIndex;

			// Store the given page in the URL, to allow restoration on refresh.
			this.$router.push( { path: this.$route.path, query: { ...this.$route.query, page: newPageIndex + 1 } } );

			// Scroll to the top of the page.
			window.scrollTo( 0, 0 );

		}
	},
	components: {
		ProductList,
		AppPagination,
		AppBreadcrumb,
		ItemsSorter,
	}
}
</script>
